/*
 * Taster.h
 *
 * Created: 10.01.2022 22:05:53
 *  Author: Alexa
 */ 

/*
Achtung das ganze benutzt standardmig Timer0 !
Init richtig machen fr den benutzen controller !

Benutzung:
		if(get_key_short(1<<KEY0))
			Sollwert=Sollwert+1000;
		
		if(get_key_long(1<<KEY0))
			Sollwert=Sollwert+10000;
		
Nur an einer Stelle der Schleife verwenden!

https://www.mikrocontroller.net/articles/Entprellung#Komfortroutine_(C_f%C3%BCr_AVR)

*/

#ifndef TASTER_H_
#define TASTER_H_

#define KEY_DDR         DDRB
#define KEY_PORT        PORTB
#define KEY_PIN         PINB
#define KEY0            0					// Einzelschlag
#define KEY1            1					// Automatik


#define ALL_KEYS        (1<<KEY0 | 1<<KEY1)

#define REPEAT_MASK     (1<<KEY0 | 1<<KEY1)					// repeat: key1, key2		Alle die auch long press knnen sollen
#define REPEAT_START    50									// after 500ms
#define REPEAT_NEXT     20									// every 200ms

#endif /* TASTER_H_ */

void Taster_init(void);

uint8_t get_key_press( uint8_t key_mask );
uint8_t get_key_rpt( uint8_t key_mask );
uint8_t get_key_state( uint8_t key_mask );
uint8_t get_key_short( uint8_t key_mask );
uint8_t get_key_long( uint8_t key_mask );