/*
 * adc.c
 *
 * Created: 13.03.2018 01:05:30
 *  Author: Alexander
 */ 

#include <avr/io.h>
#include "adc.h"

uint8_t channelold=20;

void ADC_Init(void)
{

 //########### 328P ##############################################################
  
   // die Versorgungsspannung AVcc als Referenz whlen:
  ADMUX = (1<<REFS0); 
  
   // oder interne 1.1V Referenzspannung als Referenz fr den ADC whlen:
  //ADMUX = (1<<REFS1) | (1<<REFS0); 


//########## 2560 ################################################################
  
    // die Versorgungsspannung AVcc als Referenz whlen:
 // ADMUX = (1<<REFS0); 
  
  // oder interne 1.1V Referenzspannung als Referenz fr den ADC whlen:
  //ADMUX = (1<<REFS1);
  
   // oder interne 2.56V Referenzspannung als Referenz fr den ADC whlen:
  //ADMUX = (1<<REFS1) | (1<<REFS0);
  
  //########## Tiny85 ################################################################
  
    // die Versorgungsspannung AVcc als Referenz whlen:
  // Standard 
  
  // oder interne 1.1V Referenzspannung als Referenz fr den ADC whlen:
  //ADMUX = (1<<REFS1);
  
   // oder interne 2.56V Referenzspannung als Referenz fr den ADC whlen(ohne ext. Kondensator):
  //ADMUX = (1<<REFS1) | (1<<REFS2);	

	//mit externem Kondensator:
  //ADMUX = (1<<REFS1) | (1<<REFS2)| (1<<REFS0);	
  

  // Bit ADFR ("free running") in ADCSRA steht beim Einschalten
  // schon auf 0, also single conversion
	ADCSRA = (1<<ADPS2) /*| (1<<ADPS1)*/;     // Frequenzvorteiler
//	ADCSRA = (1<<ADPS1) | (1<<ADPS0);     // Frequenzvorteiler
  ADCSRA |= (1<<ADEN);                  // ADC aktivieren

  /* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
     also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */

  ADCSRA |= (1<<ADSC);                  // eine ADC-Wandlung 
  while (ADCSRA & (1<<ADSC) ) {         // auf Abschluss der Konvertierung warten
  }
  /* ADCW muss einmal gelesen werden, sonst wird Ergebnis der nchsten
     Wandlung nicht bernommen. */
  (void) ADCW;
}


/* ADC Einzelmessung */
uint16_t ADC_Read( uint8_t channel )
{  
  // Kanal waehlen, ohne andere Bits zu beeinfluen
  ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
  
  if(channel!=channelold)				// Wenn ein neuer Kanal gewhlt wurde dann eine Leerauslesung machen.
  {
	     ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
	     while (ADCSRA & (1<<ADSC) ) {}  // auf Abschluss der Konvertierung warten
		 (void) ADCW;
  }
  ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
  while (ADCSRA & (1<<ADSC) ) {   // auf Abschluss der Konvertierung warten
  }
  channelold=channel;
  return ADCW;                    // ADC auslesen und zurckgeben
}


/* ADC Mehrfachmessung mit Mittelwertbbildung */
/* beachte: Wertebereich der Summenvariablen */
uint16_t ADC_Read_Avg( uint8_t channel, uint8_t nsamples )
{
	uint32_t sum = 0;

	for (uint8_t i = 0; i < nsamples; ++i ) {
		sum += ADC_Read( channel );
	}

	return (uint16_t)( sum / nsamples );
}

uint16_t ADC_Read_Oversample( uint8_t channel, uint8_t degree )
{
	uint32_t sum = 0;
	uint16_t max=0;
	switch(degree)
	{
		case 1:max=4;break;
		case 2:max=16;break;
		case 3:max=64;break;
		case 4:max=256;break;
		case 5:max=1024;break;	
		default:max=0;break;	
	}


	for (uint16_t i = 0; i < max; i++ ) {
		sum += ADC_Read( channel );
	}

	return (uint16_t)( sum>>degree );
}