/*
 * main.h
 *
 * Created: 31.10.2018 20:54:35
 *  Author: Alexander
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#define bit_is_set(sfr, bit)   (_SFR_BYTE(sfr) & _BV(bit))
#define bit_is_clear(sfr, bit)   (!(_SFR_BYTE(sfr) & _BV(bit)))


#define set_bit(var, bit)    ((var) |= (1 << (bit)))
#define clear_bit(var, bit)    ((var) &= (unsigned)~(1 << (bit)))
#define toggle_bit(sfr,bit)		((sfr) ^= (1 <<(bit)))
#define loop_until_bit_is_set(sfr,bit) do { } while (bit_is_clear(sfr, bit))
	
#define LED_EinzelschlagEIN set_bit(PORTD,5)
#define LED_EinzelschlagAUS clear_bit(PORTD,5)

#define LED_AutoEIN set_bit(PORTD,6)
#define LED_AutoAUS clear_bit(PORTD,6)

#define TriacEIN set_bit(PORTD,7)
#define TriacAUS clear_bit(PORTD,7)

#define Triac_Abschaltpunkt1 19000	//  9,5ms nach Nulldurchgang
#define Triac_Abschaltpunkt2 39000	// 19,5ms nach Nulldurchgang


#define P1 -1.069E-09
#define P2 2.417e-06
#define P3 -0.001416
#define P4 -0.235
#define P5 303.7


/*
Linear model Poly4:
f(x) = p1*x^4 + p2*x^3 + p3*x^2 + p4*x + p5
Coefficients (with 95% confidence bounds):
p1 =  -1.069e-09  (-1.133e-09, -1.005e-09)
p2 =   2.417e-06  (2.287e-06, 2.546e-06)
p3 =   -0.001416  (-0.001502, -0.001331)
p4 =      -0.235  (-0.2561, -0.2139)
p5 =       303.7  (302.2, 305.2)

Goodness of fit:
SSE: 2.427e+04
R-square: 0.9976
Adjusted R-square: 0.9976
RMSE: 4.936
*/
	
/*

//für >8bit variablen

#define bit_is_set(sfr, bit)	(!!((sfr) & (1ULL<<(bit))))
#define bit_is_clear(sfr, bit)	(!(!!((sfr) & (1ULL<<(bit))))

#define set_bit(var, bit)	((var) |= (1ULL<<(bit)))
#define clear_bit(var, bit)	((var) &= ~(1ULL<<(bit)))
#define toggle_bit(var,bit)	((var) ^= (1ULL<<(bit)))


*/


// Beispiel #define Reset					bit_is_clear(PIND,5)




#endif /* MAIN_H_ */